]> git.treefish.org Git - backmeupscotty.git/blobdiff - backmeupscotty
Repaired nth day option.
[backmeupscotty.git] / backmeupscotty
index 1b7fa19a1cd7c89b59afedef64b4237e5e533806..efda418d28119de54b1f9fc4617192c8ce8dd34c 100644 (file)
 #!/bin/bash
 
 REMOTE_HOST=localhost
 #!/bin/bash
 
 REMOTE_HOST=localhost
-REMOTE_BASE=/tmp/backmeupscotty
+REMOTE_DIR=/tmp/backmeupscotty/test
 ARCHIVE_KEEPNBACKUPS=30
 ARCHIVE_KEEPNDAYS=30
 ARCHIVE_KEEPNBACKUPS=30
 ARCHIVE_KEEPNDAYS=30
+BACKUP_RUNEVERYNTHDAY=1
 
 
-while getopts ":q" opt; do
-    case $opt in
-       q)
-           exec > /dev/null
-           ;;
-    esac
-done
+function upperme {
+    echo $(basename $0) | tr '[:lower:]' '[:upper:]'
+}
+
+function scottyinfo {
+    echo $(upperme): $@ 
+}
+
+function scottyerror {
+    echo $(upperme): $@ >&2 
+}
 
 function grepbackups {
 
 function grepbackups {
-    ssh $REMOTE_HOST "ls $REMOTE_BASE/$1" | grep -E '[0-9]+-[0-9]+'
+    ssh $REMOTE_HOST "ls $REMOTE_DIR" | grep -E '[0-9]+-[0-9]+'
+}
+
+function isIncomplete {
+    if ( ssh $REMOTE_HOST '[ -d '$REMOTE_DIR/incomplete' ]' ); then
+       return 0
+    else
+       return 1
+    fi
+}
+
+function isIncompleteOrNthDay {
+    if isIncomplete || \
+       [ $(( ( $(date +%s) / (60*60*24) ) % $BACKUP_RUNEVERYNTHDAY )) -eq 0 ]; 
+    then
+       return 0
+    else
+       return 1
+    fi 
 }
 
 function scottysync {
     timestamp=$(date +%s)
 
 }
 
 function scottysync {
     timestamp=$(date +%s)
 
-    echo BACKMEUPSCOTTY: Syncing $1 to $REMOTE_HOST:$REMOTE_BASE/$2 @$timestamp
+    scottyinfo Syncing $SYNC_SRC to $REMOTE_HOST:$REMOTE_DIR @$timestamp
 
 
-    dir_current=$REMOTE_BASE/$2/current
-    dir_incomplete=$REMOTE_BASE/$2/incomplete
-    dir_timestamped=$REMOTE_BASE/$2/$timestamp-$(date -d @$timestamp +%Y%m%d%H%M%S)
+    if [ ! -d "$SYNC_SRC" ]; then
+       scottyerror Source dir $SYNC_SRC does not exist. Not syncing!
+       return 1
+    fi
+
+    if [ $(ls -A "$SYNC_SRC" | wc -l) -eq 0 ]; then
+       scottyerror Source dir $SYNC_SRC is empty. Not syncing!
+       return 1
+    fi
 
 
-    if [ -z $3 ]; then
+    dir_current=$REMOTE_DIR/current
+    dir_incomplete=$REMOTE_DIR/incomplete
+    dir_timestamped=$REMOTE_DIR/$timestamp-$(date -d @$timestamp +%Y%m%d%H%M%S)
+
+    if [ -z $SYNC_EXC ]; then
        rsync_exclude=""
     else
        rsync_exclude=""
     else
-       rsync_exclude=$(eval echo --exclude={$3} | tr -d {})
+       rsync_exclude=$(eval echo --exclude={$SYNC_EXC} | tr -d {})
+    fi
+
+    if (ssh $REMOTE_HOST '[ ! -d '$REMOTE_DIR' ]'); then
+       scottyinfo Creating destination directory $REMOTE_HOST:$REMOTE_DIR
+       ssh $REMOTE_HOST "mkdir $REMOTE_DIR"
     fi
 
     fi
 
-    if (ssh $REMOTE_HOST '[ ! -d '$REMOTE_BASE/$2' ]'); then
-       echo BACKMEUPSCOTTY: Creating destination directory $REMOTE_HOST:$REMOTE_BASE/$2
-       ssh $REMOTE_HOST "mkdir $REMOTE_BASE/$2"
+    if isIncomplete; then
+       scottyerror Continuing old incomplete backup
     fi
 
     fi
 
-    echo BACKMEUPSCOTTY: Starting rsync
+    scottyinfo Starting rsync
     rsync -e ssh \
        -v -aHAX --numeric-ids --delete --delete-excluded \
        --link-dest=$dir_current \
        $rsync_exclude \
     rsync -e ssh \
        -v -aHAX --numeric-ids --delete --delete-excluded \
        --link-dest=$dir_current \
        $rsync_exclude \
-       $1/ $REMOTE_HOST:$dir_incomplete/
+       $SYNC_SRC/ $REMOTE_HOST:$dir_incomplete/
     
     if [ $? -eq 0 ]; then
     
     if [ $? -eq 0 ]; then
-       echo BACKMEUPSCOTTY: Timestamping completed backup and linking to current backup
+       scottyinfo Timestamping completed backup and linking to current backup
        ssh $REMOTE_HOST \
        ssh $REMOTE_HOST \
-           "mv $dir_incomplete $dir_timestamped && rm -f $dir_current && ln -s $dir_timestamped $dir_current"
+           "mv $dir_incomplete $dir_timestamped && rm -f $dir_current && ln -s $(basename $dir_timestamped) $dir_current"
     fi
 
     fi
 
-    while [ $(grepbackups $2 | wc -l) -gt $ARCHIVE_KEEPNBACKUPS ]; do
-       oldestbackup=$(grepbackups $2 | head -1)
+    while [ $(grepbackups | wc -l) -gt $ARCHIVE_KEEPNBACKUPS ]; do
+       oldestbackup=$(grepbackups | head -1)
        oldestbackuptstamp=$(echo $oldestbackup | cut -d'-' -f1)
 
        if [ $oldestbackuptstamp -lt $(( $(date +%s) - $ARCHIVE_KEEPNDAYS*60*60*24 )) ]; then
        oldestbackuptstamp=$(echo $oldestbackup | cut -d'-' -f1)
 
        if [ $oldestbackuptstamp -lt $(( $(date +%s) - $ARCHIVE_KEEPNDAYS*60*60*24 )) ]; then
-           echo BACKMEUPSCOTTY: Removing old backup $oldestbackup
-           ssh $REMOTE_HOST rm -r "$REMOTE_BASE/$2/$oldestbackup"
+           scottyinfo Removing old backup $oldestbackup
+           ssh $REMOTE_HOST rm -r "$REMOTE_DIR/$oldestbackup"
        else
            break
        fi
     done
 }
        else
            break
        fi
     done
 }
+
+function deleteLock {
+    if ! rmdir /tmp/$(basename $0).lock; then
+       scottyerror "Could not delete lockfile /tmp/$(basename $0).lock!"
+    fi
+}
+
+function prepare {
+    scottyinfo "Preparing for sync"
+}
+
+function cleanup_abrt {
+    scottyinfo "No cleanup_abrt function was defined."
+}
+
+function _cleanup_abrt {
+    scottyerror "Caught exit signal! Cleaning up..."
+
+    cleanup_abrt
+
+    if [ $(jobs -p) ]; then
+       scottyerror TERMinating remaining child processes...
+       kill $(jobs -p)
+    fi
+    deleteLock
+    exit
+}
+
+function prepare {
+    scottyinfo "No prepare function was defined."
+}
+
+function _prepare {
+    prepare
+}
+
+function cleanup_normal {
+    scottyinfo "No cleanup_normal function was defined."
+}
+
+function _cleanup_normal {
+    cleanup_normal
+}
+
+function backmeupscotty {
+    while getopts "qn:" opt; do
+       case $opt in
+           q)
+               exec > /dev/null
+               ;;
+           n)
+               BACKUP_RUNEVERYNTHDAY=$OPTARG
+               ;;
+       esac
+    done
+
+    if ! isIncompleteOrNthDay; then
+       scottyinfo "This is not the nth day and no incomplete backup exists."
+       exit 0
+    fi
+
+    trap _cleanup_abrt EXIT
+
+    _prepare
+    scottysync
+    _cleanup_normal
+
+    trap deleteLock EXIT
+}
+
+if ! mkdir /tmp/$(basename $0).lock; then
+    scottyerror "Another instance of $(basename $0) is still running!"
+    exit 1
+else
+    trap deleteLock EXIT
+fi